--------------------------------------------------------------------------------
-- Weapon grenade launcher
-- Original Carnage Contest Weapon inspired inspired
-- Script by DC, August 2009, www.UnrealSoftware.de (grenade)
--Modified by Thecode,September 2010
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.lancegre={}
thecode.lancegre.cluster={}

-- Load & Prepare Ressources
thecode.lancegre.gfx_wpn=loadgfx("weapons/lancegre.bmp")						-- Weapon Image
setmidhandle(thecode.lancegre.gfx_wpn)
thecode.lancegre.gfx_pro=loadgfx("weapons/grenadethe.png")					-- Projectile Image
setmidhandle(thecode.lancegre.gfx_pro)
thecode.lancegre.sfx_attack=loadsfx("glauncher.wav")							-- Attack Sound
thecode.lancegre.sfx_bounce=loadsfx("bounce.wav")
--------------------------------------------------------------------------------
-- Weapon: Grenade launcher
--------------------------------------------------------------------------------

thecode.lancegre.id=addweapon("thecode.lancegre","Grenade launcher",thecode.lancegre.gfx_wpn)		-- Add Weapon
thecode.lancegre.ammo=5											-- 30 clusters

function thecode.lancegre.draw()										-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(thecode.lancegre.gfx_wpn,6,0)
	-- HUD ammobar
	if thecode.lancegre.ammo-weapon_shots>0 then
		hudammobar(thecode.lancegre.ammo-weapon_shots,thecode.lancegre.ammo)
	end
	-- HUD Crosshair
	if thecode.lancegre.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function thecode.lancegre.attack(attack)											-- Attack
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
			if weapon_shots<thecode.lancegre.ammo and weapon_timer<=0 and attack==1 then
		-- No more weapon switching!
			useweapon(0)
			-- Reset Timer
		weapon_timer=30
	
			playsound(thecode.lancegre.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(thecode.lancegre.cluster.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+getplayerdirection(0)*7
			projectiles[id].y=getplayery(0)+2
			-- Set speed of projectile
				projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*6.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*6.0
			-- Set timer
			projectiles[id].timer=3*70
				particle(p_smoke,projectiles[id].x,projectiles[id].y)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particlecolor(255,255,255)
		particle(p_lightpuff,projectiles[id].x,projectiles[id].y)
		particlefadealpha(0.04)
		particlecolor(255,255,255)
		playerpush(0,math.sin(math.rad(getplayerrotation(0)))*-3.0,-math.cos(math.rad(getplayerrotation(0)))*3.0,1,0)


			if (weapon_shots>=thecode.lancegre.ammo) then
			-- End Turn
			endturn()
			end
		end
	
end

--------------------------------------------------------------------------------
-- Projectile: lancegre
--------------------------------------------------------------------------------

thecode.lancegre.cluster.id=addprojectile("thecode.lancegre.cluster")	-- Add Projectile

function thecode.lancegre.cluster.draw(id)						-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.lancegre.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.lancegre.cluster.update(id)						-- Update
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		-- Move X
		projectiles[id].x=projectiles[id].x+msubx
		if collision(col5x5,projectiles[id].x,projectiles[id].y,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sx)>0.5) then playsound(thecode.lancegre.sfx_bounce) end
				projectiles[id].x=projectiles[id].x-msubx
				projectiles[id].sx=-projectiles[id].sx*0.3
				msubx=-msubx*0.3
			end
		else
			projectiles[id].ignore=0
		end
		-- Move Y
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col5x5,projectiles[id].x,projectiles[id].y,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sy)>0.5) then playsound(thecode.lancegre.sfx_bounce) end
				projectiles[id].y=projectiles[id].y-msuby
				projectiles[id].sy=-projectiles[id].sy*0.3
				msuby=-msuby*0.3
				projectiles[id].sx=projectiles[id].sx*0.9
				msubx=msubx*0.9
			end
		else
			projectiles[id].ignore=0
		end		
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
	-- Timer -> Explode
	projectiles[id].timer=projectiles[id].timer-1
	if projectiles[id].timer<=0 then
		-- Cause damage
		arealdamage(projectiles[id].x,projectiles[id].y,100,50)
		-- Destroy terrain
		terrainexplosion(projectiles[id].x,projectiles[id].y,30,1)
		-- Crater
		grey=math.random(0,40)
		if math.random(0,1)==1 then
			terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		else
			terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		end
		-- Free projectile
		freeprojectile(id)
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end